<?php

/**
 * Created by PhpStorm.
 * User: David
 * Date: 7/6/2017
 * Time: 11:57 AM
 */

defined( 'ABSPATH' ) or die( "Cannot access pages directly." );
require_once ABSPATH . '/wp-content/plugins/bb-plugin/classes/class-fl-builder-model.php';

class cms_bb_conversion {
	//copy the beaver builder template in to a new page which will contain imported CMS content
	static public function copy_bb_template($template_cols) {
		//two column template
		if ($template_cols == 2) {
			$post = get_page_by_title( "Migration 2 Column", OBJECT, "fl-builder-template" );
		}

		if (isset($post)) {
			FLBuilderModel::set_post_id( $post->ID );
			$new_post_id = FLBuilderModel::duplicate_post();
			if (isset($new_post_id)) {
				return $new_post_id;
			}

		} else {
			echo "Could not find a matching Beaver Builder template";
		}
		return;
	}

	static public function add_text_content($post_id, $content, $html_id) {
		FLBuilderModel::set_post_id( $post_id );
		$column_nodes = FLBuilderModel::get_nodes( 'column' );

		foreach ( $column_nodes as $item ) {
			if ( isset( $item->settings->id ) && $item->settings->id == $html_id ) {
				$child_nodes = FLBuilderModel::get_nested_nodes( $item->node );
				foreach ( $child_nodes as $child ) {
					$html = $child->settings->text;
					$html = $html.$content;
					$child->settings->text = $html;
					FLBuilderModel::save_settings( $child->node, $child->settings );
					FLBuilderModel::save_revision( $post_id );
				}
			}
		}
	}
}