<?php
/*
Plugin Name: WHOI CMS Website Importer
Description: A plugin for reading a JSON file containing information pertaining to a WHOI CMS site and importing it into WordPress.
Version: 0.2
Author: David Gaylord
*/
defined( 'ABSPATH' ) or die( "Cannot access pages directly." );

require_once( dirname( __FILE__ ) . '/json-importer.php' );

add_action( 'admin_menu', 'cms_import_menu' );

function cms_import_menu() {
	add_management_page( 'Import Site From CMS', 'CMS Site Importer', 'administrator', 'cms-site-import-form', 'cms_site_import_form' );
}


function cms_site_import_form() {
	if ( ! current_user_can( 'administrator' ) ) {
		wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
	}

	echo "<div class=\"wrap\">";
	if ( isset( $_GET["do_import"] ) ) {  //make sure we are doing an import
		json_importer::cms_import();
	} else {

		$siteUrl = get_site_url();

		$menus = wp_get_nav_menus();

		?><h1>Import WHOI CMS site to WordPress</h1>
		<p>Enter the CMS site id of the site you wish to import.</p>
		<form action="<?php echo $siteUrl; ?>/wp-admin/tools.php" method="get">

			<input type="hidden" name="do_import" value="true"/>
			<input type="hidden" name="page" value="cms-site-import-form"/>
			<table class="form-table">
				<tr>
					<th scope="row">
						<label for="siteid">CMS Site Id: </label>
					</th>
					<td>
						<input type="text" name="site_id" value=""/>

					</td>
				</tr>
                <tr>
                    <th scope="row">
                        <label for="pageid">Alternatively enter a CMS Page Id (if migrating a section of a site): </label>
                    </th>
                    <td>
                        <input type="text" name="page_id" value=""/>

                    </td>
                </tr>
				<tr>
					<th scope="row">
						<label for="siteid">WP Menu: </label>
					</th>
					<td>
						<select name="menu_name"><?php
							foreach ( $menus as $menu ) {
								echo "<option value=\"" . $menu->name . "\">" . $menu->name . "</option>";
							}
							?></select>
					</td>
				</tr>
			</table>
			<p class="submit">
				<input type="submit" name="submit" id="submit" class="button button-primary" value="Import CMS Site"/>
			</p>

		</form>

		<?php
	}
	echo "</div>";
}

//add_action('admin_head', 'cmsImport');



