<?php

/**
 * Created by PhpStorm.
 * User: David
 * Date: 10/25/2016
 * Time: 9:11 AM
 */
defined( 'ABSPATH' ) or die( "Cannot access pages directly." );

require_once( ABSPATH . 'wp-admin' . '/includes/image.php' );
require_once( ABSPATH . 'wp-admin' . '/includes/file.php' );
require_once( ABSPATH . 'wp-admin' . '/includes/media.php' );

require_once( dirname( __FILE__ ) . '/media-utils.php' );
require_once( dirname( __FILE__ ) . '/cms-bb-conversion.php' );

class json_importer {

	public static function cms_import() {
		try {
			if ( isset( $_GET["do_import"] ) ) {  //make sure we are doing an import
				if ( current_user_can( 'administrator' ) ) {  //make sure logged in user has admin rights

					if ( !empty( $_GET["site_id"] ) || !empty( $_GET["page_id"] )) {  //check for site id, corresponds to site id of CMS site
						if ( !empty( $_GET["site_id"] )) {
							echo "Starting Migration of Site: " . $_GET["site_id"] . "<br />";

							require_once( dirname( __FILE__ ) . '/cms-utils.php' );
							CMS_Utils::cms_site_to_json( $_GET["site_id"] );
							$fileName   = "http://www-dev.whoi.edu/cms/wp-migration/site-" . $_GET["site_id"] . ".json";  //get JSON file to import from, parameterize this
						} else if  ( !empty( $_GET["page_id"] )) {
							echo "Starting Migration of Site: " . $_GET["page_id"] . "<br />";

							require_once( dirname( __FILE__ ) . '/cms-utils.php' );
							CMS_Utils::cms_page_to_json( $_GET["page_id"] );
							$fileName   = "http://www-dev.whoi.edu/cms/wp-migration/page-" . $_GET["page_id"] . ".json";  //get JSON file to import from, parameterize this
						}
						//	ob_start();

						$jsonString = file_get_contents( $fileName );
						if ( ! $jsonString ) {
							wp_die( __( 'No JSON file matching site id could be found.' ) );

						}

						$jsonArray    = json_decode( $jsonString, true );
						$curr_post_id = "";
						if ( $jsonArray == null ) {
							echo 'Failed to parse JSON file.';
							switch ( json_last_error() ) {
								case JSON_ERROR_NONE:
									echo ' - No errors';
									break;
								case JSON_ERROR_DEPTH:
									echo ' - Maximum stack depth exceeded';
									break;
								case JSON_ERROR_STATE_MISMATCH:
									echo ' - Underflow or the modes mismatch';
									break;
								case JSON_ERROR_CTRL_CHAR:
									echo ' - Unexpected control character found';
									break;
								case JSON_ERROR_SYNTAX:
									echo ' - Syntax error, malformed JSON';
									break;
								case JSON_ERROR_UTF8:
									echo ' - Malformed UTF-8 characters, possibly incorrectly encoded';
									break;
								default:
									echo ' - Unknown error';
									break;
							}
						}

						$options = $jsonArray["options"];  //get array of WordPress options
						$pages   = $jsonArray["pages"];    //get array of pages (aka WordPress posts in DB)

						$the_menu_item_id    = 0;
						$prev_parent_page_id = 0;
						$menu_item_parent_id = 0;
						$wp_parent_id        = 0;
						$id_mappings         = array();
						$landing_pages       = array();
						$use_sidebar=false;
						if ( isset( $options ) ) {
							if ( isset( $options["blogname"] ) ) {  //set the WP site name to be the same as the CMS site name
								update_site_option( "blogname", $options["blogname"] );
							}
							if ( isset( $options["tagline"] ) ) {  //set the WP site name to be the same as the CMS site name
								update_site_option( "blogdescription", $options["tagline"] );
							}
						}

						if ( isset( $pages ) ) {
							foreach ( $pages as $page ) {
								//set parent
								$cmsParentPageId = "";
								if ( isset( $page["cmsParentPageId"] ) ) {
									$cmsParentPageId = $page["cmsParentPageId"];
									if ( isset( $id_mappings[ $cmsParentPageId ] ) ) {
										$wp_parent_id        = $id_mappings[ $cmsParentPageId ];  //get the WP parent page that corresponds to the CMS parent page, mappings established at end of import method
										$page["post_parent"] = $wp_parent_id;  //set the WP parent page


									}
								}
								$curr_post_id = 0;
								//check to see if a template is specified, if it is we'll try to match it to one of the blank Beaver Builder templates
								if ( isset( $page["template_cols"] ) && (isset( $page["media"] ) || isset ($page["files"]))) {
									$template_cols = $page["template_cols"];

									if ($template_cols == 2) {
										$use_sidebar = true;
									}

									$curr_post_id = cms_bb_conversion::copy_bb_template($template_cols);
									$page["ID"] = $curr_post_id;
									if (!isset($page["post_name"])) {
										$page["post_name"] = sanitize_title($page["post_title"]);
									}
									wp_update_post( $page);
									if ( is_wp_error( $curr_post_id ) ) {
										echo "error" . $curr_post_id->get_error_message();
									}
									cms_bb_conversion::add_text_content($curr_post_id, $page["post_content"], "main-content");

								} else {
									$curr_post_id = wp_insert_post( $page, true );
									if ( is_wp_error( $curr_post_id ) ) {
										echo "error" . $curr_post_id->get_error_message();
									}
								}
								if ( $curr_post_id > 0 ) {  //post was inserted sucessfully

									echo "<br>Inserted Page: " . $page['post_title'];
									//set the homepage
									if ( isset( $page["is_homepage"] ) ) {
										update_site_option( "page_on_front", $curr_post_id );
										update_option( 'show_on_front', 'page' );
									}

									$menu_name = "main-menu";
									if ( isset( $_GET["menu_name"] ) ) {
										$menu_name = $_GET["menu_name"];
									}
									$main_menu = wp_get_nav_menu_object( $menu_name );
									$menu_id   = (int) $main_menu->term_id;
									$the_page  = get_post( $curr_post_id );
									//update list of index pages
									if ( isset( $page["is_index"] ) ) {
										array_push( $landing_pages, $curr_post_id );
									}
									if (isset ($page["featured_image"])) {
										$featured_image = media_sideload_image( $page["featured_image"], $the_page->ID );
										$res2= set_post_thumbnail( $the_page->ID, $featured_image );
									}
									if ( $the_page->post_parent == 0 ) {
										$menu_item_parent_id = 0;
									} else if ( $prev_parent_page_id != $the_page->post_parent ) {
										$menu_item_parent_id = $the_menu_item_id;
									}
									$page_data = array(
										'menu-item-object-id' => $the_page->ID,
										'menu-item-parent-id' => $menu_item_parent_id,
										'menu-item-position'  => $the_page->menu_order,
										'menu-item-object'    => 'page',
										'menu-item-type'      => 'post_type',
										'menu-item-status'    => $page['post_status']
									);

									$the_menu_item_id    = wp_update_nav_menu_item( $menu_id, 0, $page_data );
									$prev_parent_page_id = $the_page->post_parent;
									//end menu

									//the following needs to happen after post has been created

									/*LOAD IMAGES*/
									if ( isset( $page["media"] ) ) {
										media_utils::load_images( $the_page, $page["media"], $use_sidebar );
									}

									/*END LOAD IMAGES*/

									/*LOAD FILES*/
									if ( isset( $page["files"] ) ) {
										media_utils::load_files( $the_page, $page["files"], $use_sidebar );
									}

									/*END LOAD FILES*/

									/*LOAD GALLERIES*/
									if ( isset( $page["galleries"] ) ) {
										try {
											media_utils::build_rml_galleries( $the_page, $page["galleries"] );
										} catch ( Exception $e ) {
											echo 'Exception migrating gallery: ', $e->getMessage(), "\n";
										}
									}
									/*END LOAD GALLERIES*/

									/*FIND PAGE PARENT*/
									//map old cms id to new id assisged by wordpress, this can be used to create nav structure
									if ( isset( $curr_post_id ) && isset( $page["cmsId"] ) ) {
										$cmsId                 = $page["cmsId"];
										$id_mappings[ $cmsId ] = $curr_post_id;
									}
									echo "<br />Imported: " . $page["post_title"];
									/*END FIND {AGE PARENT*/
								}
							}

							if ( isset( $landing_pages ) ) {
								/*Iterate through landing pages, and create basic landing (index) page to match functionality
									from the CMS.  Need to do this after all pages have been created so that we know the WordPress permalink.*/
								foreach ( $landing_pages as $landing ) {
									$page_content = CMS_Utils::create_landing_page( $landing );
									$the_post = array(
										'ID'           => $landing,
										'post_content' => $page_content
									);
									wp_update_post( $the_post );

								}
							}
							//	ob_end_flush();
						}
					} else {
						wp_die( __( 'No Site Id Specified.' ) );
					}
				} else {
					wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
				}
			}
		} catch ( Exception $e ) {
			echo 'Exception importing site: ', $e->getMessage(), "\n";
		}

// The data to send to the API
	}
}